//combineCoordsandTextures.c

/*Copyright Arek Stankiewicz 2004,2005
 This file is part of Hugooski3D.

 Hugooski3D is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 Hugooski3D is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Hugooski3D; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include "game.h"

static float rspeed = 4.0f;
static float zspeed = 0.04f;
static float xspeed = 0.02f;
static float dspeed = 2.5f; //to get the z speed for camera movement (offset * dspeed);

void draw_screen( int* zzmove ) {
    // 1 left on x, 2 right on x, 3 down on y, 4 up on y	
    char texttoSendsl[]="please choose a key for strafe left";
    char texttoSendsr[]="please choose a key for strafe right";
    char texttoSendfw[]="please choose a key to move forward";
    char texttoSendbk[]="please choose a key to move backward";
	char texttoSendcu[]="please choose a key to move camera up";
	char texttoSendcd[]="please choose a key to move camera down";
    char fps[]="fps";
    cmMov *zmove;
    static int i=0, rotateChar=0, DoRotateChar=0,ModelCollided=0 ;
    float pos[3]= { 1.0f, 10000.0f, 510.0f };
    /* Our angle of rotation. */
    static GLfloat right = 0.0f, updown=0.0f, pan=0.0f, zoom=5.0f, scene, verticalLook;
    static GLfloat camerax,  cameray = 1.218870f, cameraz, yrot=0.0f, camerayoffset = 0.0f, camerazoffset = -5.01f; //IF WE CHANGE THESE, ALSO CHANGE BELOW
	static GLfloat PrevPan=0.0f, PrevZoom=5.0f, PrevCamerayOffset=0.0f, PrevCamerazOffset=-5.01f;
	Messages 	*ReceiveMessage;
    zmove=zzmove;
    //it to use compiled vertex arrays.    http://www.flipcode.org/cgi-bin/fcmsg.cgi?thread_show=710
	

    /* Clear the color and depth buffers. */
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    /* We don't want to modify the projection matrix. */
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity( );

    //check for collision detection, have to send camera or players x,y,z and a radius to check for each object
    //in the scene
    if(zzmove) {
		PrevPan = pan; PrevZoom = zoom; PrevCamerayOffset=camerayoffset; PrevCamerazOffset=camerazoffset;

        if (zmove->strafeLeft==1) {
            //strafe left
            right -=90.0f; //rotate, move some spaces forward
            pan += (float)sin(right*(3.14/180)) * zspeed;
            zoom += (float)cos(right*(3.14/180)) * zspeed;
            right +=90.0f; //rotate back, so looks as if strafe
            DoRotateChar=1; // tell scene engine to execute the rotation
        }
        if (zmove->strafeRight) {
            //strafe right
            right +=90.0f;
            pan += (float)sin(right*(3.14/180)) * zspeed;
            zoom += (float)cos(right*(3.14/180)) * zspeed;
            right -=90.0f;
            DoRotateChar=1; // tell scene engine to execute the rotation
        }
        if (zmove->forward) {
            //forward
            zoom-=(float)cos(right*(3.14/180)) * zspeed;
            pan -= (float)sin(right*(3.14/180)) * zspeed;
            DoRotateChar=1; // tell scene engine to execute the rotation
        }
        if (zmove->backward) {
            //backward
            zoom+=(float)cos(right*(3.14/180)) * zspeed;
            pan += (float)sin(right*(3.14/180)) * zspeed;
            DoRotateChar=1; // tell scene engine to execute the rotation
        }
		if(zmove->cameraUp) { //to change the y position of the camera
				camerayoffset -= zspeed;
				camerazoffset -= zspeed ;
		}
		if(zmove->cameraDown) {
				camerayoffset += zspeed;
				camerazoffset += zspeed;
		}
		cameray += camerayoffset;//end of positioning camera	
						
        if(zmove->lookRight) {
            //look right
            right-=zmove->rspeed;
            zmove->lookRight=0;
            yrot-=zmove->rspeed; //rotate around character, for third person view
            rotateChar=1; //tell scene engine to rotate the char to face where going but not to rotate, only rotate when we move forward
        }
        if(zmove->lookLeft) {
            //look left
            right+=zmove->rspeed;
            zmove->lookLeft=0;
            yrot+=zmove->rspeed;  //rotate around character, for third person view. Later can switch
            //between 3rd and first person :)
            rotateChar=1; //tell scene engine to rotate the char to face where going but not to rotate, only rotate when we move forward
        }
        if(zmove->lookup) {
            updown-=zmove->yspeed;//need to add
            zmove->lookup=0;
        }
        if(zmove->lookdown) {
            updown+=zmove->yspeed;
            zmove->lookdown=0;
        }
        verticalLook=360.0f - updown;
        scene= 360.0f - right;
	


        //for the camera movement, first rotate then translate
        camerax = camerazoffset * sin((yrot) * M_PI / 180) - pan;
        cameraz = camerazoffset * cos((yrot) * M_PI / 180) - zoom;
        //drawScene has no translate then rotate because nothing in the scene has its own life yet, ie move or jump etc
        glRotatef( verticalLook, 1.0f, 0.0f, 0.0f );
        glRotatef( scene, 0.0f, 1.0f, 0.0f );                                                    
        glTranslatef( camerax, cameray, cameraz );
         glLightfv( GL_LIGHT0, GL_POSITION, pos );
		//Reset Message data
		//*ReceiveArray->ModelCollided = 0;
		//*MessageData->ModelCollided = 0;
        ReceiveMessage = drawScene2( pan, 22.0f, zoom, rotateChar, DoRotateChar,  yrot, &cameray);
		ModelCollided = ReceiveMessage->ModelCollided;
		if (ModelCollided) { //We want to reset the position of the camera

				camerazoffset = PrevCamerazOffset;
				pan = PrevPan;
				zoom = PrevZoom;
				ModelCollided = 0;
			//	printf("\nHit is %d\n",ReceiveMessage->ModelCollided);
		}
		//*MessageData = *ReceiveArray;
        //drawScene2( pan, cameray, zoom, rotateChar, DoRotateChar,  yrot, &cameray);
        drawtext( fps, strlen(fps), -3.0f, 1.9f );
         //glLightfv( GL_LIGHT0, GL_POSITION, pos );
         //glDeleteTextures( 1, 1 );
        
        rotateChar=0; //we have told scene engine to rotate the character
        DoRotateChar=0;
    }else {

        switch(i) {
            case 0:
            drawtext( texttoSendsl, strlen(texttoSendsl), -3.0f, 1.9f );
            break;
            /*here the first argument is the array without brackets,
            the second is just the array size :)*/
            case 1:
            drawtext( texttoSendsl, strlen(texttoSendsl), -3.0f, 1.9f );
            
            drawtext( texttoSendsr, strlen(texttoSendsr), -3.0f, 1.79f );
            break;

            case 2:
            drawtext( texttoSendsl, strlen(texttoSendsl),  -3.0f, 1.9f );
           
            drawtext( texttoSendsr, strlen(texttoSendsr),  -3.0f, 1.79f );
        
            drawtext( texttoSendfw, strlen(texttoSendfw),  -3.0f, 1.69f );
            break;

            case 3:
            drawtext( texttoSendsl, strlen(texttoSendsl),  -3.0f, 1.9f );
         
            drawtext( texttoSendsr, strlen(texttoSendsr),  -3.0f, 1.79f );
       
            drawtext( texttoSendfw, strlen(texttoSendfw),  -3.0f, 1.69f );
      
            drawtext( texttoSendbk, strlen(texttoSendbk),  -3.0f, 1.59f );
            break;

			case 4:
            drawtext( texttoSendsl, strlen(texttoSendsl),  -3.0f, 1.9f );
            drawtext( texttoSendsr, strlen(texttoSendsr),  -3.0f, 1.79f );
            drawtext( texttoSendfw, strlen(texttoSendfw),  -3.0f, 1.69f );
            drawtext( texttoSendbk, strlen(texttoSendbk),  -3.0f, 1.59f );
			drawtext( texttoSendcu, strlen(texttoSendcu),  -3.0f, 1.49f );
            break;

			case 5:
            drawtext( texttoSendsl, strlen(texttoSendsl),  -3.0f, 1.9f );
            drawtext( texttoSendsr, strlen(texttoSendsr),  -3.0f, 1.79f );
            drawtext( texttoSendfw, strlen(texttoSendfw),  -3.0f, 1.69f );
            drawtext( texttoSendbk, strlen(texttoSendbk),  -3.0f, 1.59f );
			drawtext( texttoSendcu, strlen(texttoSendcu),  -3.0f, 1.49f );
			drawtext( texttoSendcd, strlen(texttoSendcd),  -3.0f, 1.39f );
            break;


        }
        i++;
    }


}
